import sys
import pymedia.muxer as muxer
import pymedia.video.vcodec as vcodec
import Image, ImageDraw
import time
import os
import pickle
import psyco
psyco.full()

sys.setrecursionlimit(15000)

#### Set this!!! This is where the program will dump all your files
startDir = "I:\\"


objTicker = 0


class Obj:
	def __init__(self):
		self.points = []
		self.ID = 0
		self.bounds = []
		self.frameNo = 0
	
	def addPoint(self, x, y):
		self.points += [[x,y]]
		
	def containsPoint(self,x,y):
		if len(self.bounds) == 4 and (x < self.bounds[0] or x > self.bounds[2] or y < self.bounds[1] or y > self.bounds[3]):
			return 0
		for coord in self.points:
			if coord[0] == x and coord[1] == y:
				return 1
		return 0
		
	def genBounds(self):
		minx = 65535
		miny = 65535
		maxx = -1
		maxy = -1
		for point in self.points:
			if point[0] < minx:
				minx = point[0]
			if point[1] < miny:
				miny = point[1]
			if point[0] > maxx:
				maxx = point[0]
			if point[1] > maxy:
				maxy = point[1]
		self.bounds = [minx, miny, maxx, maxy]
		
	def getBounds(self):
		return self.bounds

	def getCenter(self):
		bounds = self.bounds
		return [(bounds[0]+bounds[2])/2,(bounds[1]+bounds[3])/2]
	
	def getSize(self):
		myBounds = self.bounds#x1,y1,x2,y2
		return [myBounds[2]-myBounds[0],myBounds[3]-myBounds[1]]
		
	def getPoints(self):
		return self.points
		

def IDIn(ID, prevF):
	ID = int(ID)
	for obj in prevF:
		if obj.ID == ID:
			return 1
	return 0
		
def dirfinder(confusing):
	q = 4
	g = ""
	while q < len(confusing):
		if q > 4:
			g = g +  " " + confusing[q]
		else:
			g = g + confusing[q]
		q = q + 1
	return g

def rDirParse(inpt, prevF):
	temp = "dir \"" + inpt + "\"" + " > C:\\syssearch.txt"
	os.system(temp)
	files = open("C:\\syssearch.txt").readlines()
	i = 5
	while i < len(files)-2:
		blank = files[i].split()
		lineFile = dirfinder(blank)
		if blank[3] == "<DIR>":
			if blank[4] != "." and blank[4] != "..":
				output = rDirParse(inpt + lineFile+ "\\", prevF)
				if output < 35:
					if not IDIn(lineFile, prevF):
						os.system("del /S /F /Q "+inpt+lineFile+"\\")
						os.system("rmdir "+inpt+lineFile+"\\")
		i+=1
	return len(files)
		

def notTaken(x,y,curr):
	#curr = [ Obj, obj...]
	for myObj in curr:
		if myObj.containsPoint(x,y):
			return 0
	return 1
	
def floodFill(x,y,arr,myObj):
	myObj.addPoint(x,y)
	if x>0 and arr[y][x-1] == 1 and not myObj.containsPoint(x-1,y):
		floodFill(x-1,y,arr,myObj)
	if y>0 and arr[y-1][x] == 1 and not myObj.containsPoint(x,y-1):
		floodFill(x,y-1,arr,myObj)
	if x<len(arr[y])-1 and arr[y][x+1] == 1 and not myObj.containsPoint(x+1,y):
		floodFill(x+1,y,arr,myObj)
	if y<len(arr)-1 and arr[y+1][x] == 1 and not myObj.containsPoint(x,y+1):
		floodFill(x,y+1,arr,myObj)
	return
	
def pickler(prevF):
	global objTicker
	f = open("prevF.pck","w")
	pickle.dump(prevF, f)
	pickle.dump(objTicker, f)
	f.close()
	

def getNewID():
	global objTicker
	objTicker +=1
	return objTicker

def doExtract( inFile, inImage ):
	global objTicker
	global startDir
	start = time.time()
	now = start
	prevF = []
	curr = []

	dm= muxer.Demuxer( inFile.split( '.' )[ -1 ] )
	f= open( inFile, 'rb' )
	s= f.read( 400000 )
	r= dm.parse( s )
	v= filter( lambda x: x[ 'type' ]== muxer.CODEC_TYPE_VIDEO, dm.streams )
	if len( v )== 0:
		raise 'There is no video stream in a file %s' % inFile
	i = 1
	v_id= v[ 0 ][ 'index' ]
	print 'Assume video stream at %d index: ' % v_id
	c= vcodec.Decoder( dm.streams[ v_id ] )
	e= None

	print v
	
	frames = v[0]["frame_rate"]*v[0]["length"]
	print "number of frames:", frames
	
	myWidth = v[0]["width"]
	myHeight = v[0]["height"]
	
	mode = []
	
	#grab the moded image
	im = Image.open(inImage)
	myIm = im.tostring()
	
	try:
		getFrame = open("xtractlog.txt","r")
		startFrame = int(getFrame.read())
		getFrame.close()
		fi = open("prevF.pck","r")
		prevF = pickle.load(fi)
		objTicker = pickle.load(fi)
		fi.close()
	except:
		startFrame = 0
	
	print "STARTING AT FRAME:", startFrame
	raw_input("press enter to begin");
	
	while len( s )> 0:
		for fr in r:
			if fr[ 0 ]== v_id:
				d= c.decode( fr[ 1 ] )
				if d:
					if i > startFrame:
						diff = ""
						onediff = []
						dd= d.convert( 2 )
						point = 0
						size = len(dd.data)
						while point < size:
							if (abs(ord(myIm[point]) - ord(dd.data[point])) + abs(ord(myIm[point+1]) - ord(dd.data[point+1])) + abs(ord(myIm[point+2]) - ord(dd.data[point+2]))) > 30: #on a scale of 0-255 this would be lower but our scale is 768. i think.
								diff += chr(255)+chr(255)+chr(255)+chr(255)
								onediff += [1]
							else:
								diff += chr(0)+chr(0)+chr(0)+chr(0)
								onediff += [0]
							point += 3
						#for the next part we're going to have to do flood fills which for ease of use we should convert the strings into a matrix
						diffMat = []
						ii = 0
						while ii < myHeight:
							diffMat += [onediff[ii*myWidth:(ii+1)*myWidth]]
							ii+=1
						
						#now do the fills...
						x = 0
						y = 0
						while y < myHeight:
							x = 0
							while x < myWidth:
								if diffMat[y][x] == 1:
									if notTaken(x,y,curr):
										temp = Obj()
										floodFill(x,y, diffMat, temp)
										temp.genBounds()#cache the bounds, saves 0.5 seconds per frame!
										curr += [temp]
								x+=1
							y+=1
							
						#throw out the worthless objects (too small, probably just random particles,effects,whatever)
						#couldn't throw them out before because otherwise we'd floodfill them once for each pixel in the group...
						#which would suck.
						ix = 0
						while ix < len(curr):
							mySize = curr[ix].getSize()
							if (mySize[0] < 6 and mySize[1] <6) or ( mySize[0] < 4 or mySize[1] < 4):
								del curr[ix]
							else:
								ix +=1
						
						#now curr has all useful objects in it.
						myBase = Image.fromstring("RGB", dd.size, dd.data )
						myDiff = Image.fromstring("RGBA", dd.size, diff)
						
						myFrame = Image.new("RGBA",dd.size)
						myFrame.paste(myBase,(0,0),myDiff)
	
						
						#now compare curr to prev and assign ID values to objects that correspond to objects from previous frame
						#also assign a new ID value if we can't relate this object to a previous one.
						for myObj in curr:
							candidates = []
							myCenter = myObj.getCenter()
							mySize = myObj.getSize()
							for prevObj in prevF:
								prevCenter = prevObj.getCenter()
								prevSize = prevObj.getSize()
								if abs(myCenter[0] - prevCenter[0]) < 10 and abs(myCenter[1] - prevCenter[1]) < 10:
									if prevSize[0] < mySize[0]*2.2 and prevSize[0] > mySize[0]*0.4 and prevSize[1] < mySize[1]*2.2 and prevSize[1] > mySize[1]*0.4:
										candidates +=[prevObj]
							if len(candidates) == 1:
								myObj.ID = candidates[0].ID
								myObj.frameNo = candidates[0].frameNo+1
							elif len(candidates) > 1:
								closeness = []#smaller is better, indexes correspond to candidates
								for candidate in candidates:
									prevCenter = candidate.getCenter()
									prevSize = candidate.getSize()
									thisClose = 0 # i should probably weigh distance vs size but meh
									thisClose += abs(myCenter[0]-prevCenter[0]) + abs(myCenter[1]-prevCenter[1])
									thisClose += abs(mySize[0]-prevSize[0]) + abs(mySize[1]-prevSize[1])
									closeness += [thisClose]
								closestIndex = 0
								closestValue = 65535
								iz = 0
								while iz < len(closeness):
									if closeness[iz] < closestValue:
										closestIndex = iz
										closestValue = closeness[iz]
									iz +=1
								myObj.ID = candidates[closestIndex].ID
								myObj.frameNo = candidates[closestIndex].frameNo+1
							else:
								myObj.ID = getNewID()
								myObj.frameNo = 1
						
						#so now every object has an ID.
						#now export images and logs
	
						#img= Image.fromstring("RGB", dd.size, dd.data )
						#for myObj in curr:
						#	mySize = myObj.getSize()
						#	if mySize[0] > 5 and mySize[1]>5:
						#		draw = ImageDraw.Draw(img)
						#		draw.rectangle(myObj.getBounds(), outline=128)
						#		del draw 
						#img.save("frame.bmp" )
	
						for myObj in curr:
							if myObj.frameNo == 1:
								os.system("mkdir "+startDir+str(myObj.ID)+"\\")
							fOut = open(startDir+str(myObj.ID)+"\\log.txt","a")
							myBounds = myObj.getBounds()
							fOut.write(str(i)+" "+str(myBounds[0])+" "+str(myBounds[1])+" "+str(myBounds[2])+" "+str(myBounds[3])+"\n")
							fOut.close()
							
							xport = myFrame.crop(myObj.getBounds())
							xport.save(startDir+str(myObj.ID)+"\\"+str(i)+".png")
						
						prevF = curr
						curr = []

						theLog = open("xtractlog.txt","w")
						theLog.write(str(i))
						theLog.close()
						pickler(prevF)
						
						pf = i-startFrame
						
						prev = now
						os.system("cls")
						now = time.time()
						diff = now - start
						print "Processing Frame: ", i, "/ ", frames
						print "Time: ", round(diff,2)
						print "FPS: ", round(1/(now-prev),2)
						print "Remaining Frames:", frames-i
						remTime = ((frames-i)/(i/diff))
						remSeconds = remTime%60
						remTime -= remSeconds
						remMinutes = remTime%3600
						remTime -=remMinutes
						remMinutes = remMinutes/60
						remHours = remTime/3600
						print "Remaining Time:", int(remHours),":",int(remMinutes),":",int(remSeconds)
						print "Cumulative fps:", round((pf-1)/diff,2)
						if (i%500==0):
							rDirParse(startDir, prevF)
					else:
						if (i%300 == 0):
							os.system("cls")
							print "Tracking:", i, "/", startFrame
					i+= 1

		s= f.read( 400000 )
		r= dm.parse( s )

if __name__== '__main__':
	doExtract( sys.argv[ 1 ], sys.argv[ 2 ] )
	#infile, inimage


